using System;
using System.Drawing;

namespace PrivacyGuard.AnnotationToolkit
{
	/// <summary>
	/// Summary description for AnimationIcon.
	/// </summary>
	abstract public class AnimationIcon
	{
		public const int ALPHA = 255;

		protected Image icon;
		protected Point currPos;
		protected Point orgPos;
		protected Point destPos;
		protected bool invalidateIcon = false;
		public bool InvalidateIcon 
		{
			get 
			{
				return this.invalidateIcon;
			}
			set 
			{
				this.invalidateIcon = value;
			}
		}

		private string icon_uri = @"C:\VisualStudio\PrivacyGuard\images\warning-smaller.png";

		public AnimationIcon(Point o, Point d)
		{
			this.icon = Image.FromFile(icon_uri);
			this.orgPos = o;
			this.destPos = d;		
		}

		abstract public void UpdateAnimation(double step);
		abstract public void DisplayAnimation(Graphics g);
		abstract public void UpdateIcon(AnimationIcon ic);
	}
}
