using System;
using System.Drawing;

namespace PrivacyGuard.AnnotationToolkit
{
	/// <summary>
	/// Summary description for FlyingIcon.
	/// </summary>
	public class FlyingIcon : PrivacyGuard.AnnotationToolkit.AnimationIcon
	{
		public FlyingIcon(Point o, Point d) : base(o,d)
		{
		}
		public override void UpdateAnimation(double step)
		{
			this.currPos.X = this.orgPos.X;
			this.currPos.Y = this.destPos.Y - 
								(int) ((this.destPos.Y - this.orgPos.Y)*
									(1.0f - Math.Tan(step)/(Math.PI/2.0f)));
		}
		public override void DisplayAnimation(System.Drawing.Graphics g)
		{
			g.DrawImage(this.icon, this.currPos);
		}
		public override void UpdateIcon(AnimationIcon ic)
		{
			Point newOPos = (ic as FlyingIcon).orgPos;
			Point newDPos = (ic as FlyingIcon).destPos;
			if (!this.orgPos.Equals(newOPos) || !this.destPos.Equals(newDPos))
				this.invalidateIcon = true;
			this.orgPos = newOPos;
			this.destPos = newDPos;
		}
	}
}
