using System;
using System.Collections;
using System.IO;

namespace PrivacyGuard.BackEndImpl
{
	/// <summary>
	/// Summary description for History.
	/// </summary>
	public class History
	{
		public class HistoryEntry 
		{
			// currently the history only contains the domain name
			private string domain;
			public string Domain 
			{
				get 
				{
					return this.domain;
				}
			}
			public HistoryEntry(string domain) 
			{
				this.domain = domain;
			}
		}
		private ArrayList historylist;

		private string[] domains = 
			new string[] {
							 "ae.com", "alloy.com", "amazon.com", "apple.com",
							 "bedbathandbeyond.com", "bestbuy.com", "buy.com",
							 "compusa.com", "deepdiscountdvd.com","dvdplanet.com",
							 "ebgames.com","hollywoodvideo.com","hsn.com",
							 "kbtoys.com","kmart.com","macys.com","officemax.com",
							 "paypal.com", "pcconnection.com", "staples.com", "target.com",
							 "travelocity.com","walmart.com","yahoo.com","bloomingdales.com",
							 "radioshack.com"
						 };

		public History()
		{
			InitializeHistory();
		}

		private void InitializeHistory() 
		{
			ArrayList al = new ArrayList();
			StreamReader sr = File.OpenText(@"C:\VisualStudio\PrivacyGuard\status\config\current\nohistory.txt");
			string str = sr.ReadLine();
			while (str != null) 
			{
				al.Add(str);
				str = sr.ReadLine();
			}
			sr.Close();

			this.historylist = new ArrayList();
			for (int i = 0; i < domains.Length; i++) 
			{
				bool noh = false;
				for (int j = 0; j < al.Count; j++) 
				{
					if (domains[i].Equals(al[j]))
					{
						noh = true;
						break;
					}
				}
				if (!noh)
					this.historylist.Add(new HistoryEntry(domains[i]));
			}
		}

		public Object[] ToArray() 
		{
			return this.historylist.ToArray();
		}

		public bool InHistory(string domain) 
		{
			IEnumerator ienum = this.historylist.GetEnumerator();
			while (ienum.MoveNext()) 
			{
				HistoryEntry he = (HistoryEntry) ienum.Current;
				if (he.Domain.Equals(domain))
					return true;
			}
			return false;
		}
	}
}
