using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace PrivacyGuard.ConfirmationToolkit
{
	/// <summary>
	/// Summary description for ConfirmationDialog.
	/// </summary>
	public class ConfirmationDialog : System.Windows.Forms.Form
	{
		private IEBrowser browser;
		public IEBrowser Browser 
		{
			get 
			{
				return this.browser;
			}
		}

		private System.Windows.Forms.PictureBox warningImage;
		private System.Windows.Forms.Label warningLabel;

		private System.Windows.Forms.Panel choosingInterface;

		private System.Windows.Forms.Label promptLabel1;
		private System.Windows.Forms.Label promptLabel2;
		private PrivacyGuard.ConfirmationToolkit.RecipientArea recipientArea;
		private System.Windows.Forms.Button okButton;
		private System.Windows.Forms.Button cancelButton;

		private System.Windows.Forms.Label selectionWarning;

		private System.Windows.Forms.Panel confirmingInterface;
		private System.Windows.Forms.Label confirmLabel1;
		private RecipientArea.RecipientEntry intention;
		private System.Windows.Forms.Label confirmLabel2;
		private RecipientArea.RecipientEntry actual;
		private System.Windows.Forms.Label confirmLabel3;
		private System.Windows.Forms.Label confirmLabel4;
		private System.Windows.Forms.LinkLabel gotointention;
		private System.Windows.Forms.LinkLabel gotoactual;
		private System.Windows.Forms.Button backButton;
		private System.Windows.Forms.Button cancelButton2;

		bool isChoosing = true;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private bool isOK = false;
		public bool IsOK 
		{
			get 
			{
				return this.isOK;
			}
		}

		public ConfirmationDialog(IEBrowser b)
		{
			this.browser = b;

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ConfirmationDialog));
			this.warningImage = new System.Windows.Forms.PictureBox();
			this.warningLabel = new System.Windows.Forms.Label();

			this.choosingInterface = new System.Windows.Forms.Panel();
			this.promptLabel1 = new System.Windows.Forms.Label();
			this.promptLabel2 = new System.Windows.Forms.Label();
			this.okButton = new System.Windows.Forms.Button();
			this.cancelButton = new System.Windows.Forms.Button();
			this.selectionWarning = new System.Windows.Forms.Label();
			this.recipientArea = new RecipientArea(this);
			// 
			// warningImage
			// 
			this.warningImage.Image = ((System.Drawing.Image)(resources.GetObject("warningImage.Image")));
			this.warningImage.Location = new System.Drawing.Point(10, 10);
			this.warningImage.Name = "warningImage";
			this.warningImage.Size = new System.Drawing.Size(33, 33);
			this.warningImage.TabStop = false;
			// 
			// warningLabel
			// 
			this.warningLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.warningLabel.Location = new System.Drawing.Point(50, 10);
			this.warningLabel.Name = "warningLabel";
			this.warningLabel.Size = new System.Drawing.Size(240, 30);
			this.warningLabel.Text = "The password is sent in an unsecure way.";
			// 
			// promptLabel1
			// 
			this.promptLabel1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.promptLabel1.Location = new System.Drawing.Point(10, 0);
			this.promptLabel1.Name = "promptLabel1";
			this.promptLabel1.Size = new System.Drawing.Size(280, 30);
			this.promptLabel1.Text = "Please make sure that the password is sent to the correct website that you have sent it before.";
			// 
			// promptLabel2
			// 
			this.promptLabel2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.promptLabel2.Location = new System.Drawing.Point(10, 30);
			this.promptLabel2.Name = "promptLabel2";
			this.promptLabel2.Size = new System.Drawing.Size(280, 15);
			this.promptLabel2.Text = "Send the password to:";
			//
			// recipient area
			//
			this.recipientArea.Location = new Point(10, 50);
			// 
			// okButton
			// 
			this.okButton.Location = new System.Drawing.Point(55, 335);
			this.okButton.Name = "okButton";
			this.okButton.Size = new System.Drawing.Size(70, 20);
			this.okButton.Text = "OK";
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			// 
			// cancelButton
			// 
			this.cancelButton.Location = new System.Drawing.Point(170, 335);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.Size = new System.Drawing.Size(70, 20);
			this.cancelButton.Text = "Cancel";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// choosingInterface
			// 
			this.choosingInterface.Controls.Add(this.recipientArea);
			this.choosingInterface.Controls.Add(this.cancelButton);
			this.choosingInterface.Controls.Add(this.okButton);
			this.choosingInterface.Controls.Add(this.promptLabel2);
			this.choosingInterface.Controls.Add(this.promptLabel1);
			this.choosingInterface.Location = new System.Drawing.Point(0, 45);
			this.choosingInterface.Name = "choosingInterface";
			this.choosingInterface.Size = new System.Drawing.Size(300, 360);
			// 
			// selectionWarning
			// 
			this.selectionWarning.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.selectionWarning.ForeColor = System.Drawing.Color.Red;
			//this.selectionWarning.Location = new System.Drawing.Point(10, 332);
			this.selectionWarning.Name = "selectionWarning";
			this.selectionWarning.Size = new System.Drawing.Size(280, 15);
			this.selectionWarning.Text = "You haven\'t made a selection yet.";
			// 
			// ConfirmationDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(300, 410);
			this.Controls.Add(this.choosingInterface);
			this.Controls.Add(this.warningLabel);
			this.Controls.Add(this.warningImage);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ConfirmationDialog";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Warning";
		}
		#endregion

		private void okButton_Click(object sender, System.EventArgs e)
		{
			if (this.recipientArea.Selected == null) 
			{
				this.recipientArea.Size = new Size(280, 265);
				this.selectionWarning.Location = new Point(10, 320);
				this.choosingInterface.Controls.Add(this.selectionWarning);
			} 
			else if (!this.recipientArea.Selected.Equals(this.recipientArea.Current)) 
			{
				SwitchInterface();
			} 
			else 
			{
				this.isOK = true;
				this.Close();
			}
		}

		public void ClearWarning() 
		{
			this.recipientArea.Size = new Size(280, 280);
			this.choosingInterface.Controls.Remove(this.selectionWarning);
		}

		private void backButton_Click(object sender, System.EventArgs e) 
		{
			SwitchInterface();
		}

		private void cancelButton_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void SwitchInterface() 
		{
			if (this.isChoosing) 
			{
				this.isChoosing = false;
				if (this.confirmingInterface == null) 
				{
					this.confirmingInterface = new Panel();
					this.confirmLabel1 = new Label();
					this.confirmLabel2 = new Label();
					this.confirmLabel3 = new Label();
					this.confirmLabel4 = new Label();
					this.gotoactual = new LinkLabel();
					this.gotointention = new LinkLabel();
					this.backButton = new Button();
					this.cancelButton2 = new Button();

					this.confirmingInterface.Location = new Point(0, 45);
					this.confirmingInterface.Size = new Size(300, 360);
					this.confirmLabel1.Location = new Point(10, 0);
					this.confirmLabel1.Size = new Size(280, 15);
					this.confirmLabel1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
					this.confirmLabel1.Text = "You intend to send the password to";

					this.confirmLabel2.Location = new Point(10, 50);
					this.confirmLabel2.Size = new Size(280, 30);
					this.confirmLabel2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
					this.confirmLabel2.Text = "But the actual website that you are connecting to is";

					this.confirmLabel3.Location = new Point(10, 115);
					this.confirmLabel3.Size = new Size(280, 50);
					this.confirmLabel3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

					this.confirmLabel4.Location = new Point(10, 165);
					this.confirmLabel4.Size = new Size(280, 15);
					this.confirmLabel4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
					this.confirmLabel4.Text = "Do you want to continue?";

					this.gotointention.Location = new Point(20, 185);
					this.gotointention.Size = new Size(280, 30);
					this.gotointention.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
					this.gotointention.LinkClicked += new LinkLabelLinkClickedEventHandler(gotointention_LinkClicked);

					this.gotoactual.Location = new Point(20, 215);
					this.gotoactual.Size = new Size(280, 30);
					this.gotoactual.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
					this.gotoactual.LinkClicked += new LinkLabelLinkClickedEventHandler(gotoactual_LinkClicked);

					this.backButton.Location = new System.Drawing.Point(55, 335);
					this.backButton.Size = new System.Drawing.Size(70, 20);
					this.backButton.Text = "Back";
					this.backButton.Click += new System.EventHandler(this.backButton_Click);

					this.cancelButton2.Location = new System.Drawing.Point(170, 335);
					this.cancelButton2.Size = new System.Drawing.Size(70, 20);
					this.cancelButton2.Text = "Cancel";
					this.cancelButton2.Click += new System.EventHandler(this.cancelButton_Click);

					this.confirmingInterface.Controls.Add(this.confirmLabel1);
					this.confirmingInterface.Controls.Add(this.confirmLabel2);
					this.confirmingInterface.Controls.Add(this.confirmLabel3);
					this.confirmingInterface.Controls.Add(this.confirmLabel4);
					this.confirmingInterface.Controls.Add(this.gotoactual);
					this.confirmingInterface.Controls.Add(this.gotointention);
					this.confirmingInterface.Controls.Add(this.backButton);
					this.confirmingInterface.Controls.Add(this.cancelButton2);
				}
				this.intention = this.recipientArea.Selected.CopyEntry();
				this.intention.Location = new Point(10, 15);
				this.intention.BackColor = Color.White;
				this.intention.Radiobutton.Hide();
				this.actual = this.recipientArea.Current.CopyEntry();
				this.actual.Location = new Point(10, 80);
				this.actual.BackColor = Color.White;
				this.actual.Radiobutton.Hide();

				this.confirmLabel3.Text = "In reality " + this.actual.Domainname + " has no relationship with " + this.intention.Domainname + ".";
				this.gotointention.Text = "No. Go to " + this.intention.Domainname + " instead.";
				this.gotoactual.Text = "Yes. Continue at " + this.actual.Domainname + ".";

				this.confirmingInterface.Controls.Add(this.intention);
				this.confirmingInterface.Controls.Add(this.actual);

				this.Controls.Remove(this.choosingInterface);
				this.Controls.Add(this.confirmingInterface);
			} 
			else 
			{
				this.isChoosing = true;
				this.Controls.Remove(this.confirmingInterface);
				this.Controls.Add(this.choosingInterface);
			}
		}

		private void gotoactual_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
		{
			this.isOK = true;
			this.Close();
		}

		private void gotointention_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
		{
			this.browser.GotoSafePath(this.intention.Domainname, true);
			this.Close();
		}
	}
}
