using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Threading;
using System.Diagnostics;
using mshtml;

namespace PrivacyGuard.IEBrowserSecurityExt
{
	public class IEHTMLDocumentEvents: mshtml.HTMLDocumentEvents2
	{
		// HTMLDocumentEvent2:
		// This dispinterface provides a connection point 
		// so that an application or control 
		// can intercept events fired by a document object.

		#region Implementation of HTMLDocumentEvents2

		private PrivacyGuard.AnnotationLayer annoLayer;
		private AxSHDocVw.AxWebBrowser browsingWindow;
		private PrivacyGuard.IEBrowser browser;

		private Thread annotationCharThread = null;
		private Thread annotationIconThread = null;
		private Thread reminderbarThread = null;

		public IEHTMLDocumentEvents(PrivacyGuard.IEBrowser b, PrivacyGuard.AnnotationLayer a) 
		{
			this.browser = b;
			//this.browingWindow = b.BrowsingWindow;
			this.browsingWindow = b.GetBrowsingWindow();
			this.annoLayer = a;
		}

		public void ondataavailable(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public bool onbeforedeactivate(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public bool onstop(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public void onrowsinserted(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public bool onselectstart(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public bool onkeypress(mshtml.IHTMLEventObj pEvtObj)
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				//			if (this.browser.TrustedSite)
				//				return true;
				if (this.browser.Localize)
					return true;

				int ascii = pEvtObj.keyCode;
				if (ascii >= 32 && ascii < 126) 
				{
					PrivacyGuard.AnnotationToolkit.AnimationChar fc = 
						PrivacyGuard.PrivacyGuardUtils.IEUtil.FormAnimationChar(this.browsingWindow, ((char)ascii).ToString());
					if (fc != null) 
					{
						this.browser.WarningBar.ActivateHighlight();
						if (this.annoLayer.AnimationChar == null) 
						{
							this.annoLayer.AnimationChar = fc;
						} 
						else 
						{
							this.annoLayer.AnimationChar.UpdateChar(fc);
						}
						if (this.annotationCharThread == null ||
							!this.annotationCharThread.IsAlive)
						{
							this.annotationCharThread = 
								new Thread(new ThreadStart(this.annoLayer.DisplayAnimationChar));
							this.annotationCharThread.Start();
						}
					}
					Console.WriteLine("onkeypress accessible: " + ((char)ascii).ToString());
				}
			}
			return true;
		}
		public bool onhelp(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public void onpropertychange(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void oncellchange(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public bool oncontextmenu(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public bool ondblclick(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public void onfocusin(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void ondatasetcomplete(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void onkeyup(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void onfocusout(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void onbeforeeditfocus(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public bool ondragstart(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public bool oncontrolselect(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public void onactivate(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void onmouseup(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public bool onbeforeactivate(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public void onkeydown(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public bool onrowexit(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public bool onbeforeupdate(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public void onrowsdelete(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void onreadystatechange(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void onmousemove(mshtml.IHTMLEventObj pEvtObj)
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				if (this.browser.Localize)
					return;

				//IHTMLDocument2 doc = (IHTMLDocument2) this.browingWindow.Document;
				IHTMLDocument2 doc = this.browser.GetDocument();
				IHTMLElement body = doc.body;
				int offsetTop = (body as IHTMLElement2).scrollTop;
				int offsetLeft = (body as IHTMLElement2).scrollLeft;
				int inlineX = pEvtObj.clientX + offsetLeft;
				int inlineY = pEvtObj.clientY + offsetTop;
				bool b = this.browser.ProtectedGroup.InlineHighlight(inlineX, inlineY);
				this.browser.ReminderBar.Showbar = (b && !this.browser.Webwallet.Visible);

				// phishing-enabled code
				if (this.browser.Phishingmonitor.GetPhishingType(this.browser.GetDomainName(true))
					== PhishingAttacks.PhishingConfig.ATTACKTYPE.FAKEWW)
					this.browser.ReminderBar.Showbar = false;

				if (this.browser.ReminderBar.NeedUpdate()) 
				{
					if (this.reminderbarThread == null ||
						!this.reminderbarThread.IsAlive) 
					{
						this.reminderbarThread = 
							new Thread(new ThreadStart(this.browser.ReminderBar.UpdateLocation));
						this.reminderbarThread.Start();
					}
				}
			}
		}
		public void onrowenter(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void onafterupdate(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void ondeactivate(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void onselectionchange(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void ondatasetchanged(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void onmouseover(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public bool onmousewheel(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public bool onerrorupdate(mshtml.IHTMLEventObj pEvtObj)
		{
			return true;
		}
		public void onmouseout(mshtml.IHTMLEventObj pEvtObj)
		{

		}
		public void onmousedown(mshtml.IHTMLEventObj pEvtObj)
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				//			if (this.browser.TrustedSite)
				//				return;
				if (this.browser.Localize)
					return;

				int x = pEvtObj.screenX;
				int y = pEvtObj.screenY;
				PrivacyGuard.AnnotationToolkit.AnimationIcon ai = 
					PrivacyGuard.PrivacyGuardUtils.IEUtil.FormAnimationIcon(
					this.browser.WarningBar, this.browsingWindow, new Point(x, y));

				if (ai != null) 
				{
					this.browser.WarningBar.ActivateHighlight();
					if (this.annoLayer.AnimationIcon == null) 
					{
						this.annoLayer.AnimationIcon = ai;
					} 
					else 
					{
						this.annoLayer.AnimationIcon.UpdateIcon(ai);
					}
					if (this.annotationIconThread == null ||
						!this.annotationIconThread.IsAlive) 
					{
						this.annotationIconThread = new Thread(new ThreadStart(this.annoLayer.DisplayAnimationIcon));
						this.annotationIconThread.Start();
					}
				}
				Console.WriteLine("onmousedown accessible");
			}
		}
		public bool onclick(mshtml.IHTMLEventObj pEvtObj)
		{
			IHTMLElement elem = pEvtObj.srcElement;
			if (elem is IHTMLInputElement && 
				(elem as IHTMLInputElement).readOnly) 
			{
				PhishingAttacks.PhishingConfig.ATTACKTYPE at = 
					this.browser.Phishingmonitor.GetPhishingType(this.browser.GetDomainName(true));
				if (at != PhishingAttacks.PhishingConfig.ATTACKTYPE.IMAGEMAP &&
					at != PhishingAttacks.PhishingConfig.ATTACKTYPE.FAKEWW)
					MessageBox.Show("Please always use the Web Wallet (press the F2 key) to protect your login password submission.",
						"Web Wallet Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				else if (at == PhishingAttacks.PhishingConfig.ATTACKTYPE.IMAGEMAP) 
					MessageBox.Show("Please use Password Guard to protect your password submission.", 
						"Password Guard Warning", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
			if (elem is IHTMLInputElement) 
			{
				bool b = 
					this.browser.WebpageAnalyzer.IsSubmitButton(
					this.browser.GetDomainName(true), (elem as IHTMLInputElement));
				WebWallet.InlineProtectionToolkit.SensitiveData.SensitiveData sdata = 
					this.browser.ProtectedGroup.GetFocusedRequest();
				PhishingAttacks.PhishingConfig.ATTACKTYPE at = 
					this.browser.Phishingmonitor.GetPhishingType(this.browser.GetDomainName(true));
				if (b && sdata != null) 
				{
					WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken t = 
						sdata as WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken;
					string id = (t.Id as IHTMLInputElement).value;
					ArrayList al = t.Passwords;
					WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken.Password el = 
						(WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken.Password) al[0];
					string pwd = (el.PasswordValue as IHTMLInputElement).value;

					if (pwd.Equals(IEBrowser.LOGINPASSWORD)) 
					{
						(el.PasswordValue as IHTMLInputElement).value = 
							this.browser.SecureStorage.GetRealPassword(this.browser.GetDomainName(true));
						if (IEBrowser.WEBWALLETSTUDY) 
						{
							if (this.browser.Webwallet.SaveCard())
								this.browser.SecureStorage.AddtoLookupTable(this.browser.GetDomainName(false), this.browser.GetDomainName(true), id, pwd);
						}
					}
				}
				if (b && 
					(at == PhishingAttacks.PhishingConfig.ATTACKTYPE.FORM ||
					 at == PhishingAttacks.PhishingConfig.ATTACKTYPE.IMAGEMAP ||
					 at == PhishingAttacks.PhishingConfig.ATTACKTYPE.FAKESUG))
				{
					IHTMLInputElement pe = (this.browser.ProtectedGroup as PhishingAttacks.ProtectedGroup).PasswordInput;
					string pwd = pe.value;
					if (pwd.Equals(IEBrowser.LOGINPASSWORD)) 
					{
						pe.value = 
							this.browser.SecureStorage.GetRealPassword(this.browser.GetDomainName(true));
					}
				}
			} 
			else 
			{
				bool b = 
					this.browser.WebpageAnalyzer.IsSubmitElement(
					this.browser.GetDomainName(true), elem);
				WebWallet.InlineProtectionToolkit.SensitiveData.SensitiveData sdata = 
					this.browser.ProtectedGroup.GetFocusedRequest();
				if (b && sdata != null) 
				{
					WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken t = 
						sdata as WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken;
					string id = (t.Id as IHTMLInputElement).value;
					ArrayList al = t.Passwords;
					WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken.Password el = 
						(WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken.Password) al[0];
					string pwd = (el.PasswordValue as IHTMLInputElement).value;

					if (pwd.Equals(IEBrowser.LOGINPASSWORD)) 
					{
						(el.PasswordValue as IHTMLInputElement).value = 
							this.browser.SecureStorage.GetRealPassword(this.browser.GetDomainName(true));
						if (IEBrowser.WEBWALLETSTUDY) 
						{
							if (this.browser.Webwallet.SaveCard())
								this.browser.SecureStorage.AddtoLookupTable(this.browser.GetDomainName(false), this.browser.GetDomainName(true), id, pwd);
						}
					}
				}
			}
			return true;
			//return this.browser.ConfirmationTrigger.ContinueProcess(this.browser, pEvtObj.srcElement);
		}

		#endregion
	}

	public class IEEvents: SHDocVw.DWebBrowserEvents2
	{
		// DWebBrowserEvents2: 
		// This interface designates an event sink interface 
		// that an application must implement in order to 
		// receive event notifications from a WebBrowser control
		// or from the Microsoft Internet Explorer application. 

		#region Implementation of DWebBrowserEvents2

		private UCOMIConnectionPoint icp;
		private int cookie = -1;
		private AxSHDocVw.AxWebBrowser browsingWindow;
		private PrivacyGuard.IEBrowser browser;
		private bool alreadyAdded = false;

		public IEEvents(PrivacyGuard.IEBrowser ie)
		{
			this.browser = ie;
			// Call QueryInterface for IConnectionPointContainer
			//browsingWindow = browser.BrowsingWindow;
			this.browsingWindow = this.browser.GetBrowsingWindow();

			UCOMIConnectionPointContainer icpc =
				(UCOMIConnectionPointContainer)browsingWindow.GetOcx();

			// Find the connection point for the
			// DWebBrowserEvents2 source interface
			Guid g = typeof(SHDocVw.DWebBrowserEvents2).GUID;
			icpc.FindConnectionPoint(ref g, out icp);

			// Pass a pointer to the host to the connection point
			icp.Advise(this, out cookie);

			// Show the browser
			browsingWindow.Visible = true;
		}

		~IEEvents()
		{
			// End the connection
			if (cookie != -1) icp.Unadvise(cookie);
		}

		public void PropertyChange(string szProperty)
		{

		}
		public void UpdatePageStatus(object pDisp, ref object nPage, ref object	fDone)
		{

		}
		public void OnFullScreen(bool FullScreen)
		{

		}
		public void OnStatusBar(bool StatusBar)
		{

		}
		public void NewWindow2(ref object ppDisp, ref bool Cancel)
		{
		}
		public void NewWindow3(ref object ppDisp, ref bool Cancel, uint dwFlags, string bstrUrlContext, string bstrUrl)
		{
		}
		public void WindowSetResizable(bool Resizable)
		{

		}
		public void PrivacyImpactedStateChange(bool bImpacted)
		{

		}
		[DispId(0x00000107)]
		public void WindowClosing(bool IsChildWindow, ref bool Cancel)
		{

		}
		public void WindowSetLeft(int Left)
		{

		}
		public void OnQuit()
		{

		}
		public void FileDownload(ref bool Cancel)
		{

		}
		public void OnTheaterMode(bool TheaterMode)
		{

		}
		[DispId(0x000000fa)]
		public void BeforeNavigate2(object pDisp, ref object URL, ref object
			Flags, ref object TargetFrameName, ref object PostData, ref object
			Headers, ref bool Cancel)
		{

		}
		public void TitleChange(string Text)
		{

		}
		public void WindowSetTop(int Top)
		{

		}
		public void OnVisible(bool Visible)
		{

		}
		public void DownloadBegin()
		{
			if (!alreadyAdded) 
			{
				mshtml.HTMLDocument doc = (mshtml.HTMLDocument)browsingWindow.Document;
				UCOMIConnectionPointContainer pConPtCon = (UCOMIConnectionPointContainer)doc;
				Guid guid = typeof(mshtml.HTMLDocumentEvents2).GUID;
				UCOMIConnectionPoint pConPt;
				pConPtCon.FindConnectionPoint(ref guid, out pConPt);
				IEHTMLDocumentEvents d = new IEHTMLDocumentEvents(this.browser, this.browser.AnnotationLayer);
				pConPt.Advise(d, out IEBrowser.dwCookie2);
				alreadyAdded = true;
			}
		}

		private bool ClickEventHandler(mshtml.IHTMLEventObj e)
		{                              
			return true;
		}

		public void DownloadComplete()
		{

		}
		public void NavigateError(object pDisp, ref object URL, ref object Frame,
			ref object StatusCode, ref bool Cancel)
		{

		}
		public void OnMenuBar(bool MenuBar)
		{

		}
		public void NavigateComplete2(object pDisp, ref object URL)
		{

		}
		public void OnToolBar(bool ToolBar)
		{

		}
		public void DocumentComplete(object pDisp, ref object URL)
		{
		}
		public void PrintTemplateInstantiation(object pDisp)
		{

		}
		public void SetSecureLockIcon(int SecureLockIcon)
		{

		}
		public void ClientToHostWindow(ref int CX, ref int CY)
		{

		}
		public void ProgressChange(int Progress, int ProgressMax)
		{

		}
		public void WindowSetWidth(int Width)
		{

		}
		public void StatusTextChange(string Text)
		{

		}
		public void WindowSetHeight(int Height)
		{

		}
		public void PrintTemplateTeardown(object pDisp)
		{

		}
		public void CommandStateChange(int Command, bool Enable)
		{

		}

		#endregion
	}

}
