using System;
using System.Drawing;

namespace PrivacyGuard.IEBrowserToolkit
{
	/// <summary>
	/// Summary description for Addressbar.
	/// </summary>
	public class Addressbar : System.Windows.Forms.Panel
	{
		protected IEBrowser browser;

		private System.Windows.Forms.PictureBox address;
		private string image_uri = @"C:\VisualStudio\PrivacyGuard\images\addressbar.png";
		protected System.Windows.Forms.Label url;

		protected string urlBeingDisplayed;

		public Addressbar(IEBrowser b)
		{
			this.browser = b;
			InitializeComponent();
		}

		private void InitializeComponent() 
		{
			this.Size = new System.Drawing.Size(PrivacyGuard.IEBrowser.MAXIMIZEDX, 22);
			this.address = new System.Windows.Forms.PictureBox();
			this.address.Size = new Size(this.Size.Width, this.Size.Height);
			this.address.Image = Image.FromFile(image_uri);
			this.url = new System.Windows.Forms.Label();
			this.url.Location = new Point(70, 5);
			this.url.Size = new Size(878, 15);
			this.url.Text = "";
			this.url.Font = new Font("Tahoma", this.url.Font.Size);
			this.url.BackColor = Color.White;
			this.url.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

			this.Controls.Add(this.url);
			this.Controls.Add(this.address);
		}

		public virtual void UpdateUrl(string str) 
		{
			this.urlBeingDisplayed = str;
			this.url.Text = str.Replace("&", "&&");
		}

		public string GetProtocol() 
		{
			string protocolasprefix = PrivacyGuard.PrivacyGuardUtils.IEUtil.GetProtocolasPrefix(this.urlBeingDisplayed);
			if (protocolasprefix.Equals("https"))
				return "HyperText Transfer Protocol with Privacy";
			else
				return "HyperText Transfer Protocol";
		}
		public string GetDomainName() 
		{
			return PrivacyGuard.PrivacyGuardUtils.IEUtil.GetDomainName(this.urlBeingDisplayed);
		}
	}
}
