using System;
using System.Drawing;

namespace PrivacyGuard.IEBrowserToolkit
{
	/// <summary>
	/// Summary description for BrowsingPanel.
	/// </summary>
	public class BrowsingPanel : System.Windows.Forms.Panel 
	{
		protected IEBrowser browser;
		protected AxSHDocVw.AxWebBrowser browsingWindow;

		public BrowsingPanel (IEBrowser b) 
		{
			this.browser = b;
			InitializeComponent();
		}
		private void InitializeComponent() 
		{
			this.Location = new Point(0, IEBrowser.BROWSINGY);
			this.Size = new Size(IEBrowser.MAXIMIZEDX, IEBrowser.BROWSINGH);
		}
		public void SetBrowsingWindow(AxSHDocVw.AxWebBrowser ie) 
		{
			this.browsingWindow = ie;
		}
		public virtual void UpdateDisplay(bool border) 
		{
			if (border) 
			{
				this.browsingWindow.Location = new System.Drawing.Point(IEBrowser.BORDER, IEBrowser.BORDER);
				this.browsingWindow.Size = new System.Drawing.Size(this.Width - 2*IEBrowser.BORDER, this.Height - 2*IEBrowser.BORDER);
			}
			else 
			{
				this.browsingWindow.Location = new Point(0, 0);
				this.browsingWindow.Size = this.Size;
			}
		}
		protected override void OnPaint(System.Windows.Forms.PaintEventArgs pe) 
		{
			Graphics g = pe.Graphics;
			Pen p = new Pen(Color.OrangeRed, 5);
			g.DrawRectangle(p, 0, 0, this.Width, this.Height);
		}
	}
}
