using System;
using System.Drawing;

namespace PrivacyGuard.IEBrowserToolkit
{
	/// <summary>
	/// Summary description for Statusbar.
	/// </summary>
	public class Statusbar : System.Windows.Forms.Panel
	{
		public const int FIXEDY = 22;
		private System.Windows.Forms.PictureBox status;
		private string protected_image = @"C:\VisualStudio\PrivacyGuard\images\protected_statusbar.png";
		private string unprotected_image = @"C:\VisualStudio\PrivacyGuard\images\unprotected_statusbar.png";

		public Statusbar()
		{
			InitializeComponent();
		}

		private void InitializeComponent() 
		{
			this.Size = new System.Drawing.Size(PrivacyGuard.IEBrowser.MAXIMIZEDX, FIXEDY);
			this.status = new System.Windows.Forms.PictureBox();
			this.status.Size = new Size(this.Size.Width, this.Size.Height);
			this.status.Image = Image.FromFile(unprotected_image);
			this.Controls.Add(this.status);			
		}

		public void Secure(bool secure) 
		{
			if (secure) 
				this.status.Image = Image.FromFile(protected_image);
			else
				this.status.Image = Image.FromFile(unprotected_image);
		}
	}
}
