using System;
using System.Drawing;

namespace PrivacyGuard.WebWallet.WebWalletToolkit
{
	/// <summary>
	/// Summary description for CardFolder.
	/// </summary>
	public class CardFolder : System.Windows.Forms.Panel
	{
		private WebWalletInterface parentInterface;
		public WebWalletInterface ParentInterface 
		{
			get 
			{
				return this.parentInterface;
			}
		}

		public const int LOGIN_TAB = 0;
		public const int CREDIT_TAB = 1;
		public const int BANK_TAB = 2;
		public const int ID_TAB = 3;

		private System.Windows.Forms.TabControl tabControl;
		private System.Windows.Forms.TabPage loginCards;
		private System.Windows.Forms.TabPage creditCards;
		private System.Windows.Forms.TabPage bankCards;
		private System.Windows.Forms.TabPage personalCards;

		private LoginCardFolder logincardFolder;
		public LoginCardFolder LogincardFolder 
		{
			get 
			{
				return this.logincardFolder;
			}
		}

		//private System.Windows.Forms.Button cancelSelection;
		//private System.Windows.Forms.Button defaultSelection;

		public CardFolder(WebWalletInterface p)
		{
			this.parentInterface = p;

			InitializeComponent();
		}

		private void InitializeComponent() 
		{
			this.Location = new Point(WebWalletInterface.FOLDERX, WebWalletInterface.FOLDERY);
			this.Size = new Size(WebWalletInterface.FOLDERW, WebWalletInterface.FOLDERH);

			this.tabControl = new System.Windows.Forms.TabControl();
			this.loginCards = new System.Windows.Forms.TabPage();
			this.creditCards = new System.Windows.Forms.TabPage();
			this.bankCards = new System.Windows.Forms.TabPage();
			this.personalCards = new System.Windows.Forms.TabPage();

			this.tabControl.Location = new System.Drawing.Point(0, 0);
			this.tabControl.Size = this.Size;

			this.loginCards.Location = new System.Drawing.Point(4, 22);
			this.loginCards.Text = "Login Cards";
			this.loginCards.Size = this.Size;

			this.logincardFolder = new LoginCardFolder(this);
			this.logincardFolder.Location = new System.Drawing.Point(5, 5);
			this.logincardFolder.Size = new System.Drawing.Size(this.loginCards.Width-15,
				this.loginCards.Height-50);
			this.loginCards.Controls.Add(this.logincardFolder);
//			this.defaultSelection = new System.Windows.Forms.Button();
//			this.defaultSelection.Location = new Point(10, this.loginCards.Height-70);
//			this.defaultSelection.Size = new Size(100, 20);
//			this.defaultSelection.Text = "Default Selection";
//			this.defaultSelection.Click += new EventHandler(defaultSelection_Click);
//			this.cancelSelection = new System.Windows.Forms.Button();
//			this.cancelSelection.Location = new Point(125, this.loginCards.Height-70);
//			this.cancelSelection.Size = new Size(100, 20);
//			this.cancelSelection.Text = "Clear the selction";
//			this.cancelSelection.Click += new EventHandler(cancelSelection_Click);
//			this.loginCards.Controls.Add(this.defaultSelection);
//			this.loginCards.Controls.Add(this.cancelSelection);

			this.creditCards.Location = new System.Drawing.Point(4, 22);
			this.creditCards.Text = "Credit Cards";
			this.creditCards.Size = this.Size;

			this.bankCards.Location = new System.Drawing.Point(4, 22);
			this.bankCards.Text = "Bank Accounts";
			this.bankCards.Size = this.Size;

			this.personalCards.Location = new System.Drawing.Point(4, 22);
			this.personalCards.Text = "Personal ID Cards";
			this.personalCards.Size = this.Size;

			this.tabControl.Controls.Add(loginCards);
			this.tabControl.Controls.Add(creditCards);
			this.tabControl.Controls.Add(bankCards);
			this.tabControl.Controls.Add(personalCards);

			this.tabControl.Multiline = true;
			this.tabControl.SelectedIndex = LOGIN_TAB;

			this.Controls.Add(this.tabControl);
		}

		public void UpdateDisplay() 
		{
			this.logincardFolder.UpdateDisplay();
		}

//		private void defaultSelection_Click(object sender, System.EventArgs e) 
//		{
//			this.logincardFolder.SelectDefault();
//		}
//		private void cancelSelection_Click(object sender, System.EventArgs e) 
//		{
//			this.logincardFolder.ClearSelection();
//		}
//		public void EnableDefaultButton(bool e) 
//		{
//			this.defaultSelection.Enabled = e;
//		}
//		public void EnableClearButton(bool e) 
//		{
//			this.cancelSelection.Enabled = e;
//		}
//		public void ClearFolder() 
//		{
//			this.logincardFolder.ClearSelection();
//		}
	}
}
