using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using mshtml;

namespace PrivacyGuard.WebWallet.WebWalletToolkit.CardToolkit
{
	/// <summary>
	/// Summary description for NewLoginCard.
	/// </summary>
	public class NewLoginCard : Card
	{
		public NewLoginCard(WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken t, 
			CardToolkit.CardPageBridge g, IEBrowser b) : base(t,g,b)
		{
		}

		protected override string GetCardTitle() 
		{
			return "New Login Card";
		}
		public override string GetCardDomain() 
		{
			//return this.requestToken.Domain;
			return this.browser.GetDomainName(false);
		}

		protected override void FormValueArea() 
		{
			int x = 5;
			int y = 0;
			if (this.requestToken != null) 
			{
				IHTMLElement id = this.requestToken.Id;
				if (id != null) 
				{
					System.Windows.Forms.Label l = new System.Windows.Forms.Label();
					l.Location = new Point(x, y);
					l.Size = new Size(LABELW, ENTRYH);
					l.Text = "Login ID: username or email address";
					l.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, l.Font.Size, FontStyle.Bold);
					l.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

					y += ENTRYH;

					System.Windows.Forms.TextBox t = new System.Windows.Forms.TextBox();
					t.Location = new Point(x, y);
					t.Size = new Size(LABELW, ENTRYH);
					t.TextChanged += new EventHandler(Id_TextChanged);
					//t.Text = (id as IHTMLInputElement).value;
//					t.MouseDown += new System.Windows.Forms.MouseEventHandler(Input_MouseDown);
				
					y += ENTRYH;

					this.valueArea.Controls.Add(l);
					this.valueArea.Controls.Add(t);

					y += INTERENTRYH;

					this.bridge.AddLink(t, id);
				}
				ArrayList a = this.requestToken.Passwords;
				IEnumerator ienum = a.GetEnumerator();
				while (ienum.MoveNext()) 
				{
					WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken.Password p = 
						(WebWallet.InlineProtectionToolkit.SensitiveData.LoginToken.Password) ienum.Current;

					System.Windows.Forms.Label l = new System.Windows.Forms.Label();
					l.Location = new Point(x, y);
					l.Size = new Size(LABELW, ENTRYH);
					l.Text = "Password:";
					l.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, l.Font.Size, FontStyle.Bold);
					l.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

					y += ENTRYH;

					System.Windows.Forms.TextBox t = new System.Windows.Forms.TextBox();
					t.Location = new Point(x, y);
					t.Size = new Size(LABELW, ENTRYH);
					t.PasswordChar = '*';
					t.TextChanged += new EventHandler(Password_TextChanged);
//					t.MouseDown += new System.Windows.Forms.MouseEventHandler(Input_MouseDown);
				
					y += ENTRYH;

					this.valueArea.Controls.Add(l);
					this.valueArea.Controls.Add(t);

					y += INTERENTRYH;

					this.bridge.AddLink(t, p.PasswordValue);
				}
			} 
			else 
			{
				System.Windows.Forms.Label l = new System.Windows.Forms.Label();
				l.Location = new Point(x, y);
				l.Size = new Size(LABELW, ENTRYH);
				l.Text = "Login ID: username or email address";
				l.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, l.Font.Size, FontStyle.Bold);
				l.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

				y += ENTRYH;

				System.Windows.Forms.TextBox t = new System.Windows.Forms.TextBox();
				t.Location = new Point(x, y);
				t.Size = new Size(LABELW, ENTRYH);
				this.parent.DndDirection.UpdateIdValue(t.Text);
				t.TextChanged += new EventHandler(Id_TextChanged);
				//t.Text = (id as IHTMLInputElement).value;
				//t.MouseDown += new System.Windows.Forms.MouseEventHandler(Input_MouseDown);
				
				y += ENTRYH;

				this.valueArea.Controls.Add(l);
				this.valueArea.Controls.Add(t);

				y += INTERENTRYH;

				l = new System.Windows.Forms.Label();
				l.Location = new Point(x, y);
				l.Size = new Size(LABELW, ENTRYH);
				l.Text = "Password:";
				l.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, l.Font.Size, FontStyle.Bold);
				l.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

				y += ENTRYH;

				t = new System.Windows.Forms.TextBox();
				t.Location = new Point(x, y);
				t.Size = new Size(LABELW, ENTRYH);
				t.PasswordChar = '*';
				this.parent.DndDirection.UpdatePasswordValue(t.Text);
				t.TextChanged += new EventHandler(Password_TextChanged);
				//t.MouseDown += new System.Windows.Forms.MouseEventHandler(Input_MouseDown);
				
				y += ENTRYH;

				this.valueArea.Controls.Add(l);
				this.valueArea.Controls.Add(t);

				y += INTERENTRYH;
			}

//			if (this.authscope == null)
//				this.valueArea.Location = new Point(0, 55);
//			else
//				this.valueArea.Location = new Point(0, 75);
		}

		private void Id_TextChanged (object sender, System.EventArgs e) 
		{
			TextBox t = (TextBox) sender;
			this.parent.DndDirection.UpdateIdValue(t.Text);
		}

		private void Password_TextChanged (object sender, System.EventArgs e) 
		{
			TextBox t = (TextBox) sender;
			this.parent.DndDirection.UpdatePasswordValue(t.Text);
		}
	}
}
