using System;
using System.Windows.Forms;
using System.Drawing;

namespace PrivacyGuard.WebWallet.WebWalletToolkit
{
	/// <summary>
	/// Summary description for ConfirmingInterface.
	/// </summary>
	public class ConfirmingInterface : System.Windows.Forms.Panel
	{
		public const int HUNIT = 15;
		public const int MAXWIDTH = DataInputInterface.SECONDW;
		public const int DENTW = 10;
		public const int INTERH = 5;

//		private System.Windows.Forms.PictureBox warningimage;
//		private string image_uri = @"C:\VisualStudio\PrivacyGuard\images\warning.gif";
//		private System.Windows.Forms.Label warningtext;
		private System.Windows.Forms.Label prompt;
//		private System.Windows.Forms.Label explain1;
		private DomainComparison explain1;
		private System.Windows.Forms.LinkLabel explainlink;
		private System.Windows.Forms.Label explain2;
		private System.Windows.Forms.Label furthurprompt;
		private System.Windows.Forms.LinkLabel action1;
		private System.Windows.Forms.LinkLabel action2;
		private System.Windows.Forms.LinkLabel action3;

		private string intentedDomain;
		private string actualDomain;

		private WebWalletInterface webwallet;
		//private DataInputInterface inputInterface;

		public ConfirmingInterface(WebWalletInterface w)
		{
			this.webwallet = w;
			//this.inputInterface = this.webwallet.InputInterface;
			InitializeComponent();
		}

		private void InitializeComponent() 
		{
			this.AutoScroll = true;
			this.Location = new Point(0,0);
			this.Size = new Size(DataInputInterface.SECONDW, DataInputInterface.SECONDH);

			prompt = new Label();
			this.prompt.Location = new Point(0, 0);
			this.prompt.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, this.prompt.Font.Size, FontStyle.Bold);
			explain1 = new DomainComparison();
			explain1.LinkClicked += new LinkLabelLinkClickedEventHandler(comparison_LinkClicked);
//			explain1 = new Label();
			this.explain1.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, this.explain1.Font.Size);
			//this.explain1.LinkColor = Color.Black;
			explainlink = new LinkLabel();
			this.explainlink.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, this.explainlink.Font.Size);
			explain2 = new Label();
			this.explain2.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, this.explain2.Font.Size, FontStyle.Bold);
			this.explain2.ForeColor = Color.Red;
			furthurprompt = new Label();
			this.furthurprompt.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, this.furthurprompt.Font.Size);
			action1 = new LinkLabel();
			this.action1.LinkClicked += new LinkLabelLinkClickedEventHandler(action1_LinkClicked);
			this.action1.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, this.action1.Font.Size);
			action2 = new LinkLabel();
			this.action2.LinkClicked += new LinkLabelLinkClickedEventHandler(action2_LinkClicked);
			this.action2.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, this.action2.Font.Size);
			action3 = new LinkLabel();
			this.action3.LinkClicked += new LinkLabelLinkClickedEventHandler(action3_LinkClicked);
			this.action3.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, this.action3.Font.Size);

			this.Controls.Add(this.prompt);
			this.Controls.Add(this.explain1);
			this.Controls.Add(this.explain2);
			this.Controls.Add(this.furthurprompt);
			this.Controls.Add(this.action1);
			this.Controls.Add(this.action2);
			this.Controls.Add(this.action3);
		}

		public void UpdateDisplay(string i, string a) 
		{
			int y = 0;
			int h = 0;
			intentedDomain = i;
			actualDomain = a;

			int scrollX = this.prompt.Location.X;
			int scrollY = this.prompt.Location.Y;

			this.prompt.Text = "Are you sure you want to submit your " + intentedDomain + 
				" password to " + actualDomain + "?";
			h = PrivacyGuardUtils.WebWalletUtil.GetLabelHeight(MAXWIDTH, this.prompt) + INTERH;
			this.prompt.Size = new Size(MAXWIDTH,h);

			y += this.prompt.Height;

			if (!this.webwallet.Browser.ReputationEvaluator.IsTrustedSite(actualDomain)) 
			{
				this.explain1.Location = new Point(DENTW+scrollX, y+scrollY);
				this.explain1.Text = "If " + actualDomain + " claims to be related to " + intentedDomain + 
					", it is fraudulent because in reality " + actualDomain + 
					" has no relationship with " + intentedDomain + ".";
				h = PrivacyGuardUtils.WebWalletUtil.GetLabelHeight(MAXWIDTH-DENTW, this.explain1) + INTERH;
				this.explain1.Size = new Size(MAXWIDTH-DENTW,h);
				this.explain1.Domain1 = intentedDomain;
				this.explain1.Domain2 = actualDomain;
				
				y += this.explain1.Height;
//				this.explainlink.Location = new Point(DENTW, y);
//				this.explainlink.Text = "(Here is why)";
//				this.explainlink.Size = new Size(MAXWIDTH-DENTW, HUNIT);
//
//				y += (this.explainlink.Height+INTERH);
				this.explain2.Location = new Point(DENTW+scrollX, y+scrollY);
				this.explain2.Text = "You are highly recommended not to provide your " + intentedDomain +
					" password to " + actualDomain + ".";
				h = PrivacyGuardUtils.WebWalletUtil.GetLabelHeight(MAXWIDTH-DENTW, this.explain2)+INTERH;
				this.explain2.Size = new Size(MAXWIDTH-DENTW,h);

				y +=(this.explain2.Height+INTERH);
				this.furthurprompt.Location = new Point(0+scrollX, y+scrollY);
				this.furthurprompt.Text = "Do you want to continue?";
				this.furthurprompt.Size = new Size(MAXWIDTH, HUNIT);

				y += (this.furthurprompt.Height+INTERH);

				this.explain1.Show();
				this.explain2.Show();
				this.furthurprompt.Show();
			} 
			else 
			{
				this.explain1.Hide();
				this.explain2.Hide();
				this.furthurprompt.Hide();
			}

			this.action1.Location = new Point(DENTW+scrollX, y+scrollY);
			this.action1.Text = "No. Go to the real " + intentedDomain + " instead.";
			h = PrivacyGuardUtils.WebWalletUtil.GetLabelHeight(MAXWIDTH-DENTW, this.action1)+INTERH;
			this.action1.Size = new Size(MAXWIDTH-DENTW,h);
			
			y += this.action1.Height;
			this.action2.Location = new Point(DENTW+scrollX, y+scrollY);
			this.action2.Text = "Yes. Continue at " + actualDomain + ".";
			h = PrivacyGuardUtils.WebWalletUtil.GetLabelHeight(MAXWIDTH-DENTW, this.action2)+INTERH;
			this.action2.Size = new Size(MAXWIDTH-DENTW,h);

			y += this.action2.Height;
			this.action3.Location = new Point(DENTW+scrollX, y+scrollY);
			this.action3.Text = "No. Leave " + actualDomain + ".";
			h = PrivacyGuardUtils.WebWalletUtil.GetLabelHeight(MAXWIDTH-DENTW, this.action3)+INTERH;
			this.action3.Size = new Size(MAXWIDTH-DENTW,h);
		}

		private void action1_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
		{
			this.webwallet.InputInterface.Browser.GotoSafePath(this.intentedDomain, true);
		}
		private void action2_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)  
		{
			if (this.webwallet.InputInterface.OnlyConfirm) 
			{
				this.webwallet.InputInterface.RestoreSecondaryInterfaceAsOnlyConfirm();
				this.webwallet.InputInterface.SwitchConflictedStoredCard(this.intentedDomain);

//				this.webwallet.HideErrorInterface();
//				this.webwallet.InputInterface.SwitchStoredLoginCard(this.intentedDomain);
//				//this.webwallet.InputInterface.Submit(true);
//				//this.webwallet.InputInterface.HideChoosingInterface();
			} 
			else 
			{
				if (this.webwallet.InputInterface.DataSubmission != null) 
				{
					this.webwallet.InputInterface.Submit();
					this.webwallet.InputInterface.HideSecondaryInterface();
					this.webwallet.InputInterface.ShowNewCard(true);
				} 
				else 
				{
					this.webwallet.InputInterface.ShowSecondaryInterface(DataInputInterface.SECONDDISPLAY.DND, true);
				}
			}
		}
		private void action3_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
		{
			this.webwallet.InputInterface.Browser.GoHome();
		}

		private void comparison_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
		{
			this.webwallet.ShowSiteComparison(sender as DomainComparison);
		}
		protected override void OnPaint(System.Windows.Forms.PaintEventArgs pe) 
		{
			Graphics g = pe.Graphics;
			SolidBrush brush = new SolidBrush(Color.Black);
			SolidBrush rbrush = new SolidBrush(Color.Red);
			float x;
			float y;
			float w = 5.0F;
			float h = 5.0F;
			float offx = 8.0F;
			float offy = 5.0F;
			if (this.explain1.Visible) 
			{
				x = (float)this.explain1.Left-offx;
				y = (float)this.explain1.Top+offy;
				g.FillEllipse(brush, x, y, w, h);
			}
			if (this.explain2.Visible)
			{
				x = (float)this.explain2.Left-offx;
				y = (float)this.explain2.Top+offy;
				g.FillEllipse(rbrush, x, y, w, h);
			}
			x = (float)this.action1.Left-offx;
			y = (float)this.action1.Top+offy;
			g.FillEllipse(brush, x, y, w, h);
			y = (float)this.action2.Top+offy;
			g.FillEllipse(brush, x, y, w, h);
			y = (float)this.action3.Top+offy;
			g.FillEllipse(brush, x, y, w, h);
		}
	}
}
