using System;
using System.Drawing;
using System.Windows.Forms;

namespace PrivacyGuard.WebWallet.WebWalletToolkit
{
	/// <summary>
	/// Summary description for NoaffordanceInterface.
	/// </summary>
	public class NoaffordanceInterface : System.Windows.Forms.Panel
	{
		WebWalletInterface webwallet;

		System.Windows.Forms.Label domain;
		System.Windows.Forms.LinkLabel description;
		System.Windows.Forms.PictureBox rating;
		System.Windows.Forms.Label reminder;
		System.Windows.Forms.Label prompt;
//		System.Windows.Forms.LinkLabel loginlink;
//		System.Windows.Forms.LinkLabel creditlink;
//		System.Windows.Forms.LinkLabel banklink;
//		System.Windows.Forms.LinkLabel idlink;
//
//		System.Windows.Forms.Label warning;

		public NoaffordanceInterface(WebWalletInterface w)
		{
			this.webwallet = w;
			InitializeComponent();
		}

		private void InitializeComponent() 
		{
			this.Size = new Size(WebWalletInterface.INPUTFACEW, WebWalletInterface.INPUTFACEMH);

			this.domain = new System.Windows.Forms.Label();
			this.domain.Location = new Point(0, 0);
			this.domain.Size = new Size(this.Width, 20);
			this.domain.Font = new Font(WebWalletInterface.FONTNAME, 10, FontStyle.Bold);
			this.domain.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;

			this.description = new LinkLabel();
			this.description.Location = new Point(0, 25);
			this.description.Size = new Size(this.Width, 15);
			this.description.Font = new Font(WebWalletInterface.FONTNAME, this.description.Font.Size);
			this.description.TextAlign = ContentAlignment.MiddleCenter;
			this.description.LinkClicked += new LinkLabelLinkClickedEventHandler(description_LinkClicked);

			this.rating = new PictureBox();
			this.rating.Location = new Point((int)((this.Width-64)/2), 45);
			this.rating.Size = new Size(64, 12);

			this.reminder = new Label();
			this.reminder.Location = new Point(0, 65);
			this.reminder.Size = new Size(this.Width, 30);
			this.reminder.Text = @"Always use the Web Wallet to submit your sensitive information with this site.";

			this.prompt = new Label();
			this.prompt.Location = new Point(0, 100);
			this.prompt.Size = new Size(this.Width, 30);
			this.prompt.Text = "Choose the sensitive information that you want to submit from the card folders below.";
			this.prompt.Font = new Font(WebWalletInterface.FONTNAME, this.prompt.Font.Size);
			this.prompt.TextAlign = ContentAlignment.MiddleLeft;

//			this.loginlink = new LinkLabel();
//			this.loginlink.Location = new Point(10, 135);
//			this.loginlink.Size = new Size(this.Width-10, 15);
//			this.loginlink.Text = "Login Passwords";
//			this.loginlink.Font = new Font(WebWalletInterface.FONTNAME, this.loginlink.Font.Size);
//			this.loginlink.TextAlign = ContentAlignment.MiddleLeft;
//			this.loginlink.LinkClicked += new LinkLabelLinkClickedEventHandler(datalink_LinkClicked);
//			this.creditlink = new LinkLabel();
//			this.creditlink.Location = new Point(10, 155);
//			this.creditlink.Size = new Size(this.Width-10, 15);
//			this.creditlink.Text = "Credit Cards";
//			this.creditlink.Font = new Font(WebWalletInterface.FONTNAME, this.creditlink.Font.Size);
//			this.creditlink.TextAlign = ContentAlignment.MiddleLeft;
//			this.creditlink.LinkClicked += new LinkLabelLinkClickedEventHandler(datalink_LinkClicked);
//			this.banklink = new LinkLabel();
//			this.banklink.Location = new Point(10, 175);
//			this.banklink.Size = new Size(this.Width-10, 15);
//			this.banklink.Text = "Bank Accounts";
//			this.banklink.Font = new Font(WebWalletInterface.FONTNAME, this.banklink.Font.Size);
//			this.banklink.TextAlign = ContentAlignment.MiddleLeft;
//			this.banklink.LinkClicked += new LinkLabelLinkClickedEventHandler(datalink_LinkClicked);
//			this.idlink = new LinkLabel();
//			this.idlink.Location = new Point(10, 195);
//			this.idlink.Size = new Size(this.Width-10, 30);
//			this.idlink.Text = "Personal IDs: (Social Security Number or Driver License)";
//			this.idlink.Font = new Font(WebWalletInterface.FONTNAME, this.idlink.Font.Size);
//			this.idlink.TextAlign = ContentAlignment.MiddleLeft;
//			this.idlink.LinkClicked += new LinkLabelLinkClickedEventHandler(datalink_LinkClicked);

//			this.warning = new Label();
//			this.warning.Location = new Point(0, 235);
//			this.warning.Size = new Size(this.Width, 200);
//			this.warning.Text = "This page is very suspicous and you are highly recommanded not to continue and leave this site!";
//			this.warning.Font = new Font(WebWalletInterface.FONTNAME, 10, FontStyle.Bold);
//			this.warning.TextAlign = ContentAlignment.TopLeft;
//			this.warning.ForeColor = Color.Red;
//			this.warning.Hide();

			this.Controls.Add(this.domain);
			this.Controls.Add(this.description);
			this.Controls.Add(this.rating);
			this.Controls.Add(this.prompt);
			this.Controls.Add(this.reminder);
//			this.Controls.Add(this.loginlink);
//			this.Controls.Add(this.creditlink);
//			this.Controls.Add(this.banklink);
//			this.Controls.Add(this.idlink);
//			this.Controls.Add(this.warning);
		}

		public void UpdateDisplay() 
		{
//			this.warning.Hide();
//			string domainstr = 
//				PrivacyGuardUtils.IEUtil.GetDomainName(this.webwallet.Browser.BrowsingWindow.LocationURL);
			string domainstr = this.webwallet.Browser.GetDomainName(false);
			BackEndImpl.ReputationEvaluator.ReputationRecord rr = 
				this.webwallet.Browser.ReputationEvaluator.GetReputationRecord(domainstr);

			this.domain.Text = rr.Domain;
			this.description.Text = rr.Description;
			this.rating.Image = Image.FromFile(rr.GetRatingImage());
		}

//		private void datalink_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
//		{
//			this.warning.Show();
//		}

		private void description_LinkClicked (object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
		{
			LinkLabel ll = (LinkLabel)sender;
			Rectangle llrect = ll.RectangleToScreen(ll.ClientRectangle);
			Point tr = new Point(llrect.Left,llrect.Top);
			WebWallet.SiteReportBox amazonBox = new SiteReportBox(this.webwallet.Browser, this.domain.Text, tr);
			amazonBox.Show();
		}

//		protected override void OnPaint(System.Windows.Forms.PaintEventArgs pe) 
//		{
//			Graphics g = pe.Graphics;
//			SolidBrush brush = new SolidBrush(Color.Black);
//			float x = 2.0F;
//			float y = 0.0F;
//			float w = 5.0F;
//			float h = 5.0F;
//			float offy = 5.0F;
//			y = (float)this.loginlink.Top+offy;
//			g.FillEllipse(brush, x, y, w, h);
//			y = (float)this.creditlink.Top+offy;
//			g.FillEllipse(brush, x, y, w, h);
//			y = (float)this.banklink.Top+offy;
//			g.FillEllipse(brush, x, y, w, h);
//			y = (float)this.idlink.Top+offy;
//			g.FillEllipse(brush, x, y, w, h);
//		}
	}
}
