using System;
using System.Drawing;

namespace PrivacyGuard.WebWallet.WebWalletToolkit
{
	/// <summary>
	/// Summary description for Titlebar.
	/// </summary>
	public class Titlebar : System.Windows.Forms.Panel
	{
		private WebWalletInterface parent;
		private System.Windows.Forms.Label title;
		private System.Windows.Forms.PictureBox close;
		private string image_uri = @"C:\VisualStudio\PrivacyGuard\images\close.gif";
		private System.Windows.Forms.LinkLabel user;
		private System.Windows.Forms.LinkLabel help;

		public Titlebar(WebWalletInterface p)
		{
			this.parent = p;
			//
			// TODO: Add constructor logic here
			//
			InitializeComponent();
		}
		private void InitializeComponent() 
		{
			this.Location = new System.Drawing.Point(0, 0);
			this.Size = new System.Drawing.Size(IEBrowser.WEBWALLETW, WebWalletInterface.TITLEH);

			this.title = new System.Windows.Forms.Label();
			this.title.Location = new System.Drawing.Point(2, 2);
			this.title.Size = new System.Drawing.Size(220, 16);
			this.title.Text = "John Smith's Web Wallet";
			this.title.Font = new Font(WebWallet.WebWalletInterface.FONTNAME, 10, FontStyle.Bold);
			this.title.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

			this.close = new System.Windows.Forms.PictureBox();
			this.close.Location = new Point(230, 2);
			this.close.Size = new Size(16,15);
			this.close.Image = Image.FromFile(image_uri);
			this.close.Click += new EventHandler(close_Click);

			this.user = new System.Windows.Forms.LinkLabel();
			this.user.Location = new Point(2, 22);
			this.user.Size = new System.Drawing.Size(100, 16);
			this.user.Text = "Switch Users ...";
			this.user.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;

			this.help = new System.Windows.Forms.LinkLabel();
			this.help.Location = new Point(150, 22);
			this.help.Size = new Size(98, 16);
			this.help.Text = "Help";
			this.help.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.help.LinkClicked +=new System.Windows.Forms.LinkLabelLinkClickedEventHandler(help_LinkClicked);

			this.Controls.Add(this.title);
			this.Controls.Add(this.close);
			this.Controls.Add(this.user);
			this.Controls.Add(this.help);
		}

		private void close_Click(object sender, System.EventArgs e) 
		{
			this.parent.Close();
		}

		private void help_LinkClicked (object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
		{
			this.parent.Browser.GotoTutorial();
		}
	}
}
