using System;
using mshtml;

namespace PrivacyGuard.PhishingAttacks
{
	/// <summary>
	/// Summary description for BrowsingPanel.
	/// </summary>
	public class BrowsingPanel : IEBrowserToolkit.BrowsingPanel
	{
		private PhishingAttacks.WebWalletInterface fakeww;
		private PhishingAttacks.OnlineKeyboard onlinekb;

		public BrowsingPanel(IEBrowser b) : base(b)
		{
		}

		public void AddWebWallet() 
		{
			if (this.fakeww != null && this.Controls.Contains(this.fakeww))
				this.Controls.Remove(this.fakeww);
			this.fakeww = new WebWalletInterface(this.browser);
			this.Controls.Add(this.fakeww);
		}
		public void RemoveWebWallet() 
		{
			if (this.fakeww != null && this.Controls.Contains(this.fakeww))
				this.Controls.Remove(this.fakeww);
			this.fakeww = null;
		}
		public void AddOnlineKeyBoard(IHTMLInputElement elem) 
		{
			if (this.onlinekb != null && this.Controls.Contains(this.onlinekb))
				this.Controls.Remove(this.onlinekb);
			this.onlinekb = new OnlineKeyboard(this.browser, elem);
			this.Controls.Add(this.onlinekb);
		}
		public void RemoveOnlineKeyBoard() 
		{
			if (this.onlinekb != null && this.Controls.Contains(this.onlinekb)) 
			{
				this.onlinekb.StopTimer();
				this.Controls.Remove(this.onlinekb);
			}
			this.onlinekb = null;
		}
		public override void UpdateDisplay(bool border)
		{
			if (!border)
				base.UpdateDisplay (border);
			else 
			{
				if (this.fakeww != null && this.Controls.Contains(this.fakeww)) 
				{
					this.browsingWindow.Location = new System.Drawing.Point(IEBrowser.BORDER, IEBrowser.BORDER);
					this.browsingWindow.Size = new System.Drawing.Size(this.Width-2*IEBrowser.BORDER-this.fakeww.Width, this.Height-2*IEBrowser.BORDER);
					this.fakeww.Location = new System.Drawing.Point(IEBrowser.BORDER+this.browsingWindow.Width, IEBrowser.BORDER);
				} 
				else if (this.onlinekb != null && this.Controls.Contains(this.onlinekb)) 
				{
					this.onlinekb.Location = new System.Drawing.Point(IEBrowser.BORDER, IEBrowser.BORDER);
					this.onlinekb.Size = new System.Drawing.Size(this.Width-2*IEBrowser.BORDER, 100);
					//this.onlinekb.UpdateDisplay();
					this.browsingWindow.Location = new System.Drawing.Point(IEBrowser.BORDER, IEBrowser.BORDER+this.onlinekb.Height);
					this.browsingWindow.Size = new System.Drawing.Size(this.Width-2*IEBrowser.BORDER, this.Height-2*IEBrowser.BORDER-this.onlinekb.Height);
				}
				else 
				{
					this.browsingWindow.Location = new System.Drawing.Point(IEBrowser.BORDER, IEBrowser.BORDER);
					this.browsingWindow.Size = new System.Drawing.Size(this.Width - 2*IEBrowser.BORDER, this.Height - 2*IEBrowser.BORDER);
				}
			}
		}

		public bool ContainsFakeWebWallet() 
		{
			return (this.fakeww != null);
		}
		public bool ContainsOnlineKeyBoard() 
		{
			return (this.onlinekb != null);
		}
	}
}
