using System;
using System.Collections;
using System.IO;

namespace PrivacyGuard.PhishingAttacks
{
	/// <summary>
	/// Summary description for PhishingConfig.
	/// </summary>
	public class PhishingConfig
	{
		public enum ATTACKTYPE {NONE, HOLDER, FORM, IMAGEMAP, FAKEWW, FAKESUG};
		public static string IPAddress = "126.11.70.24";
		private Hashtable configuration;

		public class PhishingRecord 
		{
			private string domainName;
			public string DomainName 
			{
				get 
				{
					return this.domainName;
				}
			}
			private string phishingHost;
			public string PhishingHost 
			{
				get 
				{
					return this.phishingHost;
				}
			}
			private ATTACKTYPE phishingType; 
			public ATTACKTYPE PhishingType 
			{
				get 
				{
					return this.phishingType;
				}
			}
			public PhishingRecord (string d, string p, ATTACKTYPE t) 
			{
				this.domainName = d;
				this.phishingHost = p;
				this.phishingType = t;
			}
		}
		public PhishingConfig()
		{
			this.configuration = new Hashtable();
			InitializeData();
		}
		private void InitializeData() 
		{
			StreamReader sr = File.OpenText(@"C:\VisualStudio\PrivacyGuard\status\config\current\phishing.txt");
			for (int i = 0; i < 5; i++) 
			{
				string d;
				string pd;
				int a;
				ATTACKTYPE at = ATTACKTYPE.NONE;
				d = sr.ReadLine();
				pd = sr.ReadLine();
				a = Int32.Parse(sr.ReadLine());
				switch(a) 
				{
					case 1:
						at = ATTACKTYPE.HOLDER;
						break;
					case 2:
						at = ATTACKTYPE.FORM;
						break;
					case 3:
						at = ATTACKTYPE.FAKEWW;
						break;
					case 4:
						at = ATTACKTYPE.IMAGEMAP;
						break;
					case 5:
						at = ATTACKTYPE.FAKESUG;
						break;
					default:
						break;
				}
				this.configuration.Add(d, new PhishingRecord(d, pd, at));
			}
			sr.Close();
//			this.configuration.Add("apple.com", new PhishingRecord("apple.com", "secure.ssl-apple-department.com", ATTACKTYPE.FAKEWW));
//			this.configuration.Add("buy.com", new PhishingRecord("buy.com", "www.buy.com.ww2.us", ATTACKTYPE.FORM));
//			this.configuration.Add("macys.com", new PhishingRecord("macys.com", "www.macys-online.com", ATTACKTYPE.HOLDER));
//			this.configuration.Add("compusa.com", new PhishingRecord("compusa.com", "compusa-inc-secure.com", ATTACKTYPE.IMAGEMAP));
//			this.configuration.Add("target.com", new PhishingRecord("target.com", "service.target-online.com", ATTACKTYPE.FAKESUG));
		}

		public string GetPhishingHost(string d) 
		{
			if (d == null)
				return null;
			PhishingRecord r = (PhishingRecord) this.configuration[d];
			if (r != null)
				return r.PhishingHost;
			else
				return null;
		}
		public ATTACKTYPE GetPhishingType(string d) 
		{
			if (d == null)
				return ATTACKTYPE.NONE;
			PhishingRecord r = (PhishingRecord) this.configuration[d];
			if (r != null)
				return r.PhishingType;
			else
				return ATTACKTYPE.NONE;
		}
		public void RemoveAttack(string domain) 
		{
			if (domain != null)
				this.configuration.Remove(domain);
		}
	}
}
