using System;
using System.Collections;
using System.Drawing;
using mshtml;

namespace PrivacyGuard.PhishingAttacks
{
	/// <summary>
	/// Summary description for ProtectedGroup.
	/// </summary>
	public class ProtectedGroup : WebWallet.InlineProtectionToolkit.ProtectedGroup
	{
		private IHTMLInputElement passwordInput;
		public IHTMLInputElement PasswordInput 
		{
			get 
			{
				return this.passwordInput;
			}
		}

		public ProtectedGroup(IEBrowser b) : base(b)
		{
		}

		public override void FormProtectedGroup(IHTMLDocument2 doc, bool h) 
		{
			this.passwordInput = null;

			if (doc == null)
				return;

			if (IEBrowser.WEBWALLETSTUDY) 
			{
				string domain = PrivacyGuardUtils.IEUtil.GetDomainName(doc.url);
				PhishingConfig.ATTACKTYPE at = this.browser.Phishingmonitor.GetPhishingType(domain);
//				if (at == PhishingConfig.ATTACKTYPE.FORM)// || at == PhishingConfig.ATTACKTYPE.IMAGEMAP) 
//				{
//					this.groups = new System.Collections.ArrayList();
//					this.focus = null;
//					return;
//				}

				this.groups = analyzer.HardcodedAnalyze(doc);

				if (this.groups.Count == 0) 
					this.focus = null;
				else 
				{
					if (at == PhishingConfig.ATTACKTYPE.FORM ||
						at == PhishingConfig.ATTACKTYPE.FAKESUG)
					{
						this.passwordInput = MaskCurrentPassword(false);
						this.groups = new System.Collections.ArrayList();
						this.focus = null;
					}
					else if (at == PhishingConfig.ATTACKTYPE.IMAGEMAP) 
					{
						this.passwordInput = MaskCurrentPassword(false);
						this.passwordInput.readOnly = true;
						this.groups = new System.Collections.ArrayList();
						this.focus = null;
					} 
					else if (at == PhishingConfig.ATTACKTYPE.FAKEWW) 
					{
						this.focus = this.groups[0] as ProtectedHolder;
						this.InlineAnnotation(doc);
						this.focus.ForceHighlight(true);
						this.passwordInput = MaskCurrentPassword(true);
					} 
					else 
					{
						this.focus = this.groups[0] as ProtectedHolder;
						this.InlineAnnotation(doc);
						this.focus.ForceHighlight(h);
					}
				}
			} 
			else 
			{
				this.groups = analyzer.HardcodedAnalyze(doc);
				if (this.groups.Count == 0) 
					this.focus = null;
				else 
				{
					this.focus = this.groups[0] as ProtectedHolder;
				}
			}
		}

		private IHTMLInputElement MaskCurrentPassword(bool b) 
		{
			ProtectedHolder ph = this.groups[0] as ProtectedHolder;
			ArrayList ai = ph.Items;
			IEnumerator ienum = ai.GetEnumerator();
			while (ienum.MoveNext()) 
			{
				ProtectedInput pi = (ProtectedInput) ienum.Current;
				if (pi.SensitiveType.Equals(WebWallet.ConstantAttributes.INPUTTYPE.LOGIN_PASSWORD)) 
				{
					IHTMLInputElement pinput = pi.Elem;
//					if (pinput.readOnly)
//						pinput.readOnly = false;
					if (b)
					{
						pinput.readOnly = true;
						(pinput as IHTMLElement).style.backgroundColor = ProtectedGroup.READYONLYCOLOR;
					}
					return pinput;
				}
			}
			return null;
		}
	}
}
