using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.Threading;
using mshtml;

namespace PrivacyGuard.PhishingAttacks
{
	/// <summary>
	/// Summary description for SuggestionForm.
	/// </summary>
	public class SuggestionForm : System.Windows.Forms.Form
	{
		public class RecipientArea : System.Windows.Forms.Panel 
		{
			private IEBrowser browser;
			private SuggestionForm parent;
			private ArrayList entries;

			public const int ENTRYX = 0;
			public const int ENTRYY = 2;

			private RecipientEntry selected;
			public RecipientEntry Selected 
			{
				get 
				{
					return this.selected;
				}
			}
			private RecipientEntry current;
			public RecipientEntry Current
			{
				get 
				{
					return this.current;
				}
			}

			public class RecipientEntry : System.Windows.Forms.Panel 
			{
				public const string FONTNAME = "Tahoma";
				public const int MAXWIDTH = WebWallet.WebWalletInterface.INPUTFACEW-17;
				public const int DOMX = 20;
				public const int DESX = 20;
				public const int DOMY = 0;
				public const int HUNIT = 15;
				public const int RATY = 2;
				public const int RATW = 65;
				public const int RATH = 12;
				public const int RATX = MAXWIDTH-RATW;
//				public const int MAXDOMWIDTH = MAXWIDTH-DOMX-RATW;
				public const int MAXDOMWIDTH = MAXWIDTH-DOMX;
				public const int MAXDESWIDTH = MAXWIDTH-DESX;

				private System.Windows.Forms.RadioButton radiobutton;
				public System.Windows.Forms.RadioButton Radiobutton 
				{
					get 
					{
						return this.radiobutton;
					}
				}

				private System.Windows.Forms.Label domain;
				private string domainname;
				public string Domainname 
				{
					get 
					{
						return this.domainname;
					}
				}

				private WebWallet.WebWalletToolkit.DomainDescription description;
				private string despstr;

//				private System.Windows.Forms.PictureBox rating;
//				private string imageuri;

				private BackEndImpl.ReputationEvaluator.ReputationRecord record;

				private RecipientArea parent;

				public RecipientEntry(RecipientArea p, BackEndImpl.ReputationEvaluator.ReputationRecord rr) 
				{
					this.parent = p;
					this.record = rr;
					this.domainname = this.record.Domain;
					this.despstr = this.record.Description;
//					this.imageuri = this.record.GetRatingImage();

					InitializeComponent();
				}

				private void InitializeComponent() 
				{
					this.radiobutton = new System.Windows.Forms.RadioButton();
					this.radiobutton.Size = new Size(10, 10);
					this.radiobutton.Text = "";
					this.radiobutton.Click += new EventHandler(entry_Click);

					this.domain = new System.Windows.Forms.Label();
					this.domain.Location = new Point(DOMX, DOMY);
					this.domain.Text = this.domainname;
					this.domain.Font = new Font(FONTNAME, this.domain.Font.Size, FontStyle.Bold);
					int preferW = this.domain.PreferredWidth;
					int hu = (int) Math.Ceiling((double)preferW/(double)MAXDOMWIDTH);
					this.domain.Size = new Size(MAXDOMWIDTH, HUNIT*hu);
					this.domain.Click += new EventHandler(entry_Click);
					this.domain.MouseMove += new System.Windows.Forms.MouseEventHandler(entry_MouseMove);

					this.description = new PrivacyGuard.WebWallet.WebWalletToolkit.DomainDescription(this.domainname);
					this.description.Location = new Point(DESX, this.domain.Height);
					this.description.Text = this.despstr;
					if (!this.record.IsTrustedSite())
						this.description.LinkColor = Color.Red;
					this.description.Font = new Font(FONTNAME, this.description.Font.Size, FontStyle.Italic);
					preferW = this.description.PreferredWidth;
					hu = (int)Math.Ceiling((double)preferW/(double)MAXDESWIDTH);
					this.description.Size = new Size(MAXDESWIDTH, HUNIT*hu);
//					this.description.LinkClicked += new LinkLabelLinkClickedEventHandler(description_LinkClicked);

//					this.rating = new System.Windows.Forms.PictureBox();
//					this.rating.Location = new Point(RATX, RATY);
//					this.rating.Size = new Size(RATW, RATH);
//					this.rating.Image = Image.FromFile(this.imageuri);
//					this.rating.Click += new EventHandler(entry_Click);
//					this.rating.MouseMove += new System.Windows.Forms.MouseEventHandler(entry_MouseMove);

					int actualh = this.domain.Height+this.description.Height;
					this.radiobutton.Location = new Point(5, (actualh-10)/2);
					this.Size = new Size(MAXWIDTH, actualh);

					this.Controls.Add(this.radiobutton);
					this.Controls.Add(this.domain);
					this.Controls.Add(this.description);
//					this.Controls.Add(this.rating);

					this.MouseDown += new MouseEventHandler(this.parent.parent.Form_MouseDown);
					this.radiobutton.MouseDown += new MouseEventHandler(this.parent.parent.Form_MouseDown);
					this.domain.MouseDown += new MouseEventHandler(this.parent.parent.Form_MouseDown);
//					this.rating.MouseDown += new MouseEventHandler(this.parent.parent.Form_MouseDown);
				}

				private void entry_Click(object sender, System.EventArgs e) 
				{
					(this.Parent as RecipientArea).SelectEntry(this);
				}
				private void entry_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e) 
				{
					Cursor.Current = Cursors.Hand;
				}
//				private void description_LinkClicked (object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) 
//				{
//					(this.Parent as RecipientArea).browser.Webwallet.ShowSiteReport(sender as DomainDescription);
//				}
			}

			public RecipientArea(SuggestionForm p, IEBrowser b)
			{
				this.parent = p;
				this.browser = b;
				this.entries = new ArrayList();
			}

			public void UpdateDisplay() 
			{
				this.Controls.Clear();
				this.selected = null;
				string ipname = this.browser.GetDomainName(false);
				string truedomain = this.browser.GetDomainName(true);
				string fakedomain = GetDomainfromHost(this.browser.Phishingmonitor.GetPhishingHost(truedomain));
				ArrayList al = new ArrayList();
				Object[] ha = 
					new Object[] {
									 new BackEndImpl.History.HistoryEntry("amazon.com"),
									 new BackEndImpl.History.HistoryEntry("bestbuy.com"),
									 new BackEndImpl.History.HistoryEntry("buy.com"),
									 new BackEndImpl.History.HistoryEntry("ebay.com"),
									 new BackEndImpl.History.HistoryEntry("kmart.com"),
									 new BackEndImpl.History.HistoryEntry("macys.com"),
									 new BackEndImpl.History.HistoryEntry("expedia.com"),
									 new BackEndImpl.History.HistoryEntry("target.com"),
									 new BackEndImpl.History.HistoryEntry("travelocity.com"),
									 new BackEndImpl.History.HistoryEntry("paypal.com"),
									 new BackEndImpl.History.HistoryEntry("yahoo.com"),
									 new BackEndImpl.History.HistoryEntry("compusa.com")
								 };
				for (int i = 0; i < ha.Length; i++) 
				{
					string dom = ((BackEndImpl.History.HistoryEntry) ha[i]).Domain;
					if (!dom.Equals(truedomain)) 
					{
						al.Add(this.browser.ReputationEvaluator.GetReputationRecord(dom));
					}
				}
				al.Add(
					new BackEndImpl.ReputationEvaluator.ReputationRecord( 
					fakedomain, "A trusted shopping site", 5.0, true, true, "", false, "", "", false, null));
//				al.Add(
//					new BackEndImpl.ReputationEvaluator.ReputationRecord( 
//					ipname, "An unrecognized site with no trust", 0.0, false, false, "", true, "","", false, null));

//				int chunk = BackEndImpl.ReputationEvaluator.SortReputationRecords(ref al);
				BackEndImpl.ReputationEvaluator.SortReputationRecords(ref al);

				this.BackColor = Color.White;
				this.AutoScroll = true;

				int y = ENTRYY;
				bool addbkcolor = false;
				for (int i = 0; i < al.Count; i++) 
				{
					BackEndImpl.ReputationEvaluator.ReputationRecord record = (BackEndImpl.ReputationEvaluator.ReputationRecord) al[i];
					RecipientEntry re = new RecipientEntry(this, record);
					this.entries.Add(re);
					re.Location = new Point(ENTRYX, y);
					re.BackColor = addbkcolor ? Color.LightGray : Color.White;
					this.Controls.Add(re);
					y += re.Height;
					addbkcolor = !addbkcolor;
				}
			}

			public void SelectEntry(RecipientEntry e) 
			{
				this.parent.EnableButton();
				this.selected = e;
				IEnumerator ienum = this.entries.GetEnumerator();
				while (ienum.MoveNext()) 
				{
					RecipientEntry c = (RecipientEntry) ienum.Current;
					c.Radiobutton.Checked = (c.Equals(e));
				}
			}
			protected override void OnPaint(System.Windows.Forms.PaintEventArgs pe) 
			{
				Graphics g = pe.Graphics;
				Pen pn = new Pen(Color.Black);
				Point start = new Point(0,0);
				Point end = new Point(this.Width,0);
				g.DrawLine(pn, start, end);
			}


			public static string GetDomainfromHost(string hostname) 
			{
				string[] s = Regex.Split(hostname, Regex.Escape("."));
				int size = s.Length;
				string domainname = s[size-2] + "." + s[size-1];
				return domainname;
			}
		}

		private IEBrowser browser;

//		private AxSHDocVw.AxWebBrowser axWebBrowser1;
		private IEBrowserSecurityToolkit.Warningbar warningbar;
		private IEBrowserToolkit.BrowsingPanel browsingPanel;
		private System.Windows.Forms.Panel table;
		private System.Windows.Forms.Label domainColumn;
		private System.Windows.Forms.Label ratingColumn;
		private RecipientArea area;
		private System.Windows.Forms.Label prompt1;
		private System.Windows.Forms.Label prompt2;
		private System.Windows.Forms.Label prompt3;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;

		private WebWallet.WebWalletInterface webwallet = null;
//		private int f2keycounter = 0;
		private bool enlarged = false;

		Thread annotationIconThread;
		private System.Windows.Forms.Timer timer;
		private EventHandler timerHandler;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SuggestionForm(IEBrowser b)
		{
			this.browser = b;
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SuggestionForm));

			this.warningbar = new PrivacyGuard.IEBrowserSecurityToolkit.Warningbar(this.browser);
			this.warningbar.Location = new Point(0, 0);
			this.warningbar.Size = new Size(800, 30);
			this.warningbar.Help.Location = new Point(this.warningbar.Width-110, 0);

			this.browsingPanel = new PrivacyGuard.IEBrowserToolkit.BrowsingPanel(browser);
			this.browsingPanel.Location = new Point(0, 30);
			this.browsingPanel.Size = new Size(800, 450);

			this.prompt1 = new Label();
			this.prompt1.Location = new Point(285, 5);
			this.prompt1.Size = new Size(230, 45);
			string ipname = this.browser.GetDomainName(false);
			this.prompt1.Text = "This web site " + ipname + " is known as a fraudulent site to trick you into disclosing your sensitive information.";
			this.prompt1.Font = new Font(WebWalletInterface.FONTNAME, this.prompt1.Font.Size);
			this.prompt1.TextAlign = ContentAlignment.MiddleLeft;

			this.prompt2 = new Label();
			this.prompt2.Location = new Point(285, 55);
			this.prompt2.Size = new Size(230, 30);
			this.prompt2.Text = "You\'re highly recommended to stop providing any information at this site.";
			this.prompt2.Font = new Font(WebWalletInterface.FONTNAME, this.prompt2.Font.Size, FontStyle.Bold);
			this.prompt2.ForeColor = Color.Red;
			this.prompt2.TextAlign = ContentAlignment.MiddleLeft;

			this.prompt3 = new Label();
			this.prompt3.Location = new Point(285, 90);
			this.prompt3.Size = new Size(230, 30);
			this.prompt3.Text = "Does " + ipname + " claim to be any of the following sites?";
			this.prompt3.Font = new Font(WebWalletInterface.FONTNAME, this.prompt3.Font.Size);
			this.prompt3.TextAlign = ContentAlignment.MiddleLeft;

			this.table = new Panel();
			this.domainColumn = new System.Windows.Forms.Label();
			this.ratingColumn = new System.Windows.Forms.Label();
			this.table.Location = new Point(285, 125);
			this.table.Size = new Size(230, this.browsingPanel.Height-this.table.Top-70);
			this.table.BorderStyle = BorderStyle.FixedSingle;

			this.domainColumn.Font = 
				new System.Drawing.Font(WebWallet.WebWalletInterface.FONTNAME,
				this.domainColumn.Font.Size, System.Drawing.FontStyle.Bold);
			this.domainColumn.Location = new System.Drawing.Point(15, 0);
			this.domainColumn.Size = new System.Drawing.Size(100, 15);
			this.domainColumn.Text = "Web Site";
			this.domainColumn.TextAlign = System.Drawing.ContentAlignment.BottomLeft;

			this.ratingColumn.Font = 
				new System.Drawing.Font(WebWallet.WebWalletInterface.FONTNAME,
				this.ratingColumn.Font.Size, System.Drawing.FontStyle.Bold);
			this.ratingColumn.Location = new System.Drawing.Point(148, 0);
			this.ratingColumn.Size = new System.Drawing.Size(80, 15);
			this.ratingColumn.Text = "Trust Rating";
			this.ratingColumn.TextAlign = System.Drawing.ContentAlignment.BottomRight;

			this.area = new RecipientArea(this, this.browser);
			this.area.Location = new Point(0, 15);
			this.area.Size = new Size(this.table.Width, this.table.Height-15);
			this.area.UpdateDisplay();

			this.table.Controls.Add(this.domainColumn);
			this.table.Controls.Add(this.ratingColumn);
			this.table.Controls.Add(this.area);

			this.domainColumn.MouseDown += new MouseEventHandler(Form_MouseDown);
			this.ratingColumn.MouseDown += new MouseEventHandler(Form_MouseDown);
			this.area.MouseDown += new MouseEventHandler(Form_MouseDown);

			this.button1 = new Button();
			this.button1.Location = new Point(this.table.Left, this.table.Bottom+10);
			this.button1.Size = new Size(this.table.Width, 20);
			this.button1.Text = "Go to the selected site";
			this.button1.Font = new Font(WebWalletInterface.FONTNAME, this.button1.Font.Size);
			this.button1.TextAlign = ContentAlignment.MiddleCenter;
			this.button1.Enabled = false;
			this.button1.Click +=new EventHandler(button1_Click);

			this.button2 = new Button();
			this.button2.Location = new Point(this.table.Left, this.table.Bottom+40);
			this.button2.Size = new Size(this.table.Width, 20);
			this.button2.Text = "Continue at "+ipname;
			this.button2.Font = new Font(WebWalletInterface.FONTNAME, this.button2.Font.Size);
			this.button2.TextAlign = ContentAlignment.MiddleCenter;
			this.button2.Click +=new EventHandler(button2_Click);

			this.browsingPanel.Controls.Add(prompt1);
			this.browsingPanel.Controls.Add(prompt2);
			this.browsingPanel.Controls.Add(prompt3);
			this.browsingPanel.Controls.Add(this.table);
			this.browsingPanel.Controls.Add(this.button1);
			this.browsingPanel.Controls.Add(this.button2);

			this.browsingPanel.MouseDown += new MouseEventHandler(Form_MouseDown);
			this.prompt1.MouseDown += new MouseEventHandler(Form_MouseDown);
			this.prompt2.MouseDown += new MouseEventHandler(Form_MouseDown);
			this.prompt3.MouseDown += new MouseEventHandler(Form_MouseDown);
			this.button1.MouseDown += new MouseEventHandler(Form_MouseDown);
			this.button2.MouseDown += new MouseEventHandler(Form_MouseDown);
			// 
			// SuggestionForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(800, 480);
//			this.Controls.Add(this.axWebBrowser1);
			this.Controls.Add(this.warningbar);
			this.Controls.Add(this.browsingPanel);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "SuggestionForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Location = new Point(112, 134);
			this.Text = "Web Wallet Warning";
			this.Closing += new CancelEventHandler(SuggestionForm_Closing);
//			((System.ComponentModel.ISupportInitialize)(this.axWebBrowser1)).EndInit();

			this.timer = this.browser.WarningTimer;
			timerHandler = new EventHandler(timer_Tick);
			//this.timer.Tick += new EventHandler(timer_Tick);
			this.timer.Tick += timerHandler;

			//this.Closing += new CancelEventHandler(SuggestionForm_Closing);
		}
		#endregion

//		private void SuggestionForm_Closing(object sender, System.ComponentModel.CancelEventArgs e) 
//		{
//			this.browser.Phishingmonitor.ContinueWithIP = true;
//			this.browser.Phishingmonitor.AcknowledgeIP = true;
//		}

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData) 
		{
//			this.f2keycounter++;
//			if (this.f2keycounter%2 == 1) 
//			{
				if (keyData == Keys.F2) 
				{
					if (this.webwallet == null) 
					{
						this.webwallet = new PrivacyGuard.WebWallet.WebWalletInterface(browser);
						this.Controls.Add(this.webwallet);
						this.webwallet.UpdateDisplay();
						this.webwallet.Hide();
					}
					if (!this.webwallet.Visible)
						ShowWebWallet();
					else
						HideWebWallet();
				}
//			}
			return base.ProcessCmdKey(ref msg, keyData);
		}

		private void ShowWebWallet() 
		{
			if (!enlarged) 
			{
				this.Location = new Point(112, 59);
				this.ClientSize = new Size(800, IEBrowser.WEBWALLETH);
				this.webwallet.Location = new Point(this.ClientSize.Width-IEBrowser.WEBWALLETW, 0);
				this.enlarged = true;
			}

			this.warningbar.Hide();
			this.webwallet.Show();
			this.browsingPanel.Location = new Point(0, 0);
			this.browsingPanel.Size = new Size(this.ClientSize.Width-IEBrowser.WEBWALLETW, this.ClientSize.Height);
			this.prompt1.Location = new Point(160, this.prompt1.Top);
			this.prompt2.Location = new Point(160, this.prompt2.Top);
			this.prompt3.Location = new Point(160, this.prompt3.Top);
			this.table.Location = new Point(160, this.table.Top);
			this.table.Size = new Size(230, this.browsingPanel.Height-this.table.Top-70);
			this.area.Size = new Size(230, this.table.Height-15);
			this.button1.Location = new Point(160, this.table.Bottom+10);
			this.button2.Location = new Point(160, this.table.Bottom+40);
			this.browsingPanel.Refresh();
		}

		private void HideWebWallet() 
		{
			this.warningbar.Show();
			this.webwallet.Hide();
			this.browsingPanel.Location = new Point(0, 30);
			this.browsingPanel.Size = new Size(this.ClientSize.Width, this.ClientSize.Height-30);
			this.prompt1.Location = new Point(285, this.prompt1.Top);
			this.prompt2.Location = new Point(285, this.prompt2.Top);
			this.prompt3.Location = new Point(285, this.prompt3.Top);
			this.table.Location = new Point(285, this.table.Top);
			this.table.Size = new Size(230, this.browsingPanel.Height-this.table.Top-70);
			this.area.Size = new Size(230, this.table.Height-15);
			this.button1.Location = new Point(285, this.table.Bottom+10);
			this.button2.Location = new Point(285, this.table.Bottom+40);
			this.browsingPanel.Refresh();
		}

		public void EnableButton() 
		{
			this.button1.Enabled = true;
		}

		private void button1_Click(object sender, System.EventArgs e) 
		{
			string truedomain = this.browser.GetDomainName(true);
			string fakedomain = RecipientArea.GetDomainfromHost(this.browser.Phishingmonitor.GetPhishingHost(truedomain));
			string selectiondomain = this.area.Selected.Domainname;
			if (selectiondomain.Equals(fakedomain)) 
			{
				this.browser.GotoSafePath(truedomain, false);
				this.browser.Phishingmonitor.ContinueWithIP = false;
				this.browser.Phishingmonitor.AcknowledgeIP = true;
			} 
			else 
			{
				this.browser.GotoSafePath(selectiondomain, false);
				this.browser.Phishingmonitor.ContinueWithIP = false;
				this.browser.Phishingmonitor.AcknowledgeIP = true;
			}
			this.Close();
		}

		private void button2_Click(object sender, System.EventArgs e) 
		{
			this.browser.Phishingmonitor.ContinueWithIP = true;
			this.browser.Phishingmonitor.AcknowledgeIP = true;
			this.Close();
		}

		private void SuggestionForm_Closing(object sender, System.ComponentModel.CancelEventArgs e) 
		{
			this.timer.Tick -= timerHandler; 
		}

		public void Form_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) 
		{
			Point p = ((Control) sender).PointToScreen(new Point(e.X, e.Y));
			PrivacyGuard.AnnotationToolkit.AnimationIcon ai = 
				PrivacyGuard.PrivacyGuardUtils.IEUtil.FormAnimationIcon(
				this.warningbar, p);

			if (ai != null) 
			{
				this.warningbar.ActivateHighlight();
				if (this.browser.AnnotationLayer.AnimationIcon == null) 
				{
					this.browser.AnnotationLayer.AnimationIcon = ai;
				} 
				else 
				{
					this.browser.AnnotationLayer.AnimationIcon.UpdateIcon(ai);
				}
				if (this.annotationIconThread == null ||
					!this.annotationIconThread.IsAlive) 
				{
					this.annotationIconThread = new Thread(new ThreadStart(this.browser.AnnotationLayer.DisplayAnimationIcon));
					this.annotationIconThread.Start();
				}
			}
		}

		private void timer_Tick(object sender, System.EventArgs e) 
		{
			this.warningbar.UpdateHighlight();
		}


	}
}
